/*****************************************************************************
 *	Includes / define
 ****************************************************************************/
//system includes
#include	<math.h>
#include	<stdio.h>
#include	<stdlib.h>

//other includes
#include	"dll.h"

/*****************************************************************************
 *	Definition of main functions
 ****************************************************************************/

extern "C"
{
int Binning2x2(int dim, int dim_x, int dim_y, float* a, float* b, int sat)
{
    for (int p=0; p<dim; p++)
    {
        /* visit all pixels of the output image and assign their value */
        for (int i = 0; i < dim_x/2; i++) {
        for (int j = 0; j < dim_y/2; j++) {

            if (int(a[p*dim_x*dim_y + 2*i*dim_y + 2*j])==sat)
            {
                b[p*(dim_x/2)*(dim_y/2) + i*(dim_y/2) + j] = float(sat);
            }
            else if (int(a[p*dim_x*dim_y + 2*i*dim_y + 2*j+1])==sat)
            {
                b[p*(dim_x/2)*(dim_y/2) + i*(dim_y/2) + j] = float(sat);
            }
            else if (int(a[p*dim_x*dim_y + (2*i+1)*dim_y + 2*j])==sat)
            {
                b[p*(dim_x/2)*(dim_y/2) + i*(dim_y/2) + j] = float(sat);
            }
            else if (int(a[p*dim_x*dim_y + (2*i+1)*dim_y + 2*j+1])==sat)
            {
                b[p*(dim_x/2)*(dim_y/2) + i*(dim_y/2) + j] = float(sat);
            }
            else
            {
                b[p*(dim_x/2)*(dim_y/2) + i*(dim_y/2) + j] = 0.25*(a[p*dim_x*dim_y + 2*i*dim_y + 2*j] + a[p*dim_x*dim_y + 2*i*dim_y + 2*j+1] + a[p*dim_x*dim_y + (2*i+1)*dim_y + 2*j] + a[p*dim_x*dim_y + (2*i+1)*dim_y + 2*j+1]);
            }
        }}
    }
	return(0);
}
}
