# -*- coding: iso_8859_1 -*-
"""
	module for aperture photometry.
"""

#--- all necessary modules --
#import os, datetime, time, sys, pp, warnings
#import itertools as it 
#import numpy as np
#import matplotlib.pyplot as plt
#import matplotlib.font_manager as fm
#from matplotlib.backends.backend_pdf import PdfPages
#----------------------------
#from aspylib import astro, conf
#----------------------------

from aspylib.photometry.photometry1 import check_pictures_quality
#def check_pictures_quality(outputname, Imagelist):

from aspylib.photometry.photometry2 import calculate_shifts
#def calculate_shifts(outputname, Imagelist, fit_area = 10, nb_stars = 12, parallel=True):

from aspylib.photometry.photometry3 import make_photometry, aperture_photometry
#def make_photometry(Imagelist, sizes, coord, method='centroid', check_sat=[True,'saturation'], mag_sat=np.nan, mag_zero=np.nan, error_messages=1):
#def aperture_photometry(image, sizes, coord, method='centroid', check_sat=[True,'saturation'], mag_sat=np.nan, mag_zero=np.nan, error_messages=1):

from aspylib.photometry.photometry4 import make_photometrystats, aperture_photometrystats
#def make_photometrystats(Imagelist, sizes, coord, CCD, method='centroid', check_sat=[True,'saturation'], mag_sat=[np.nan, np.nan], mag_zero=[np.nan, np.nan], error_messages=1):
#def aperture_photometrystats(image, sizes, coord, CCD, method='centroid', check_sat=[True,'saturation'], mag_sat=[np.nan, np.nan], mag_zero=[np.nan, np.nan], error_messages=1):

from aspylib.photometry.photometry5 import load_shifts, load_imagestats
#def load_shifts(filename):
#def load_imagestats(filename):

from aspylib.photometry.photometry6 import write_magnitudes, write_magnitudes_and_SNR
#def write_magnitudes(outputname, Imagelist, names, coord, dateobs, sizes, mag, datation='start'):
#def write_magnitudes_and_SNR(outputname, Imagelist, names, coord, dateobs, sizes, mag, SNR, datation='start'):

#------------------------------------------------------------------------------------------------------------
from aspylib.photometry.photo_script1 import select_stars
#def select_stars(Imagelist, shifts, pdfname, fit_area=10, method='centroid'):

from aspylib.photometry.photo_script2 import check_refstars
#def check_refstars(names, mag):

from aspylib.photometry.photo_script3 import filter_magnitudes
#def filter_magnitudes(obj_index, names, sizes, mag_ok, rejdata):

from aspylib.photometry.photo_script4 import calc_noise, best_magnitude
#def calc_noise(mag):
#def best_magnitude(obj_index, names, sizes, mag_i, rejstar, rejdata_i, rejdisk_i, nb=10):

from aspylib.photometry.photo_script5 import write_best_magnitude
#def write_best_magnitude(outputname, Imagelist, names, obj_index, sizes, dateobs, ref_1, mag_1, sig_1, rejdata_i, rejsizes=[], rejstar=[], nb=10, datation='start'):

from aspylib.photometry.photo_script6 import write_cdrcdl_report
#def write_cdrcdl_report(outputname, Imagelist, names, obj_index, dateobs, mag_i, ref_1, mag_1, sig_1, rejdata_i, format='DVR'):

#------------------------------------------------------------------------------------------------------------
from aspylib.photometry.automatic_script1 import compute_statistics
#def compute_statistics(mag, nbref=20, plotting=False):

from aspylib.photometry.automatic_script2 import write_auto_magnitudes
#def write_auto_magnitudes(outputname, Imagelist, xy, sizes, dateobs, diff_mag, diff_stats, quality_flag, which_disk, ref_stars, datation='start', astrometry = []):
